#!/boot/home/config/bin/perl

# version 1.2

# this script grabs the latest version of Apache available on the 
# apache FTP server and builds it on BeOS.  You need to have 
# wget installed:
#	http://www.be.com/software/beware/network/wget.html
# The wget archive has a bunch of items, but all you really need is to 
# put the wget program in your /boot/home/config/bin/ folder.
# You also should have Perl installed - it is part of the optional 
# items on the BeOS CD.  

# Put this script in /boot/home/apachesrc/ (create folder if needed) 
# and run it from the commandline.

# if you want to run this regularly, 
# AutoFolderLauncher (http://home.beoscentral.com/TMS/)
# may work fine every 24 hours to do this, or you can use cron 
# (http://www.be.com/software/beware/utilities/cron.html).  
# Also (and more successful for me), Scheduler will do it too, 
# and easier.  http://www.bedepot.com/products/tietz/Scheduler.asp

# Buy Scheduler and support a BeOS developer.  It's the best 
# product of the three named, in my opinion.

# You can run this script by hand too if you want, or if your 
# network connection isn't continous.   It installs Apache to 
# /boot/home/apache/ - be careful if you already have something there.

# this currently checks for the default index page and the two CGIs 
# in Apache's /cgi-bin: printenv and test-cgi.  Both the actual web 
# results and what wget reports are saved to the results.txt file - 
# it's a bit of a jumble.

# running the script from the command line with the "short" 
# option: "-s" will make it skip the lengthy download/build part and 
# just run the server test section without grabbing the latest version.  
# (assuming you have already downloaded it once...)  There's a new version 
# every 6 hours, last I checked.

# Modified by Greg Kellogg [kelloggs@home.com] on 06.02.2000 to run autoconf 
# in the shemem module

use Cwd 'chdir';

$arg = shift;

unless ($arg eq "-s")
{
	system("rm", "-r", "/boot/home/apachesrc/apache-2.0/") if (-e "/boot/home/apachesrc/apache-2.0/"); 

	# commented out because of the slight chance 
	# this might really screw someone up that has 
	# important material at these locations.

	#system("rm", "-r", "/boot/home/apache/") if (-e "/boot/home/apache");
	#system("mkdir", "/boot/home/apache/"); 
	
	system("wget", "--output-document=/boot/home/apachesrc/apachebuildtemp",
		"-q", "http://dev.apache.org/from-cvs/apache-2.0/");
	
	open(LISTING,"/boot/home/apachesrc/apachebuildtemp");
	while (<LISTING>)
	{
		m/>(apache-2\.0_\d\d\d\d\d\d\d\d\d\d\d\d\d\d\.tar\.gz)</;	
		$result = $1 if (defined($1));
	}
	close (LISTING);
	
	unlink "/boot/home/apachesrc/apachebuildtemp";	
	
	system("wget","--output-document=/boot/home/apachesrc/$result",
		"-q", "http://dev.apache.org/from-cvs/apache-2.0/$result");
	
	$tar = $result;
	$tar =~ s/\.gz//;
	
	system("gzip", "-d","/boot/home/apachesrc/$result");
	unlink "/boot/home/apachesrc/$result";
	
	system("tar", "--directory=/boot/home/apachesrc", "-x", "-v", "-f", "/boot/home/apachesrc/$tar" );
	unlink "/boot/home/apachesrc/$tar";
	
# Begin addition by gkellogg
	
	chdir "/boot/home/apachesrc/apache-2.0/src/lib/apr/shmem/unix/mm";

	system("autoconf");

# End addition by gkellogg	
	
	chdir "/boot/home/apachesrc/apache-2.0";
	
	system(
		"/boot/home/apachesrc/apache-2.0/configure",
		"--prefix=/boot/home/apache",
		"--set-rule=MPM_METHOD:mpmt_beos",
		"--enable-module=cgi",
		"--enable-module=status",
		);
		
	system("make");
	system("make","install");
}
	
	
system("/boot/home/apache/bin/httpd &");

# I've noticed that starting Apache has a second or two of lag 
# time, so this sleep command is here to make sure Apache 
# gets a chance to start up before I start hitting it.
sleep 100; 
	
# grab a set of pages and save the results.
%results_hash = 
( 
	"results1.txt" => "http://127.0.0.1/",
	"results2.txt" => "http://127.0.0.1/cgi-bin/test-cgi",
	"results3.txt" => "http://127.0.0.1/cgi-bin/printenv",
);

# clear out logfile
open(RESULTS,">/boot/home/apachesrc/results.txt");
print RESULTS "\n";
close(RESULTS);

foreach $key (sort keys %results_hash)
{
	system("wget", "--output-document=/boot/home/apachesrc/$key",
		 "--append-output=/boot/home/apachesrc/$key", "$results_hash{$key}");

	open(RESULT,">>/boot/home/apachesrc/results.txt");
	open(TEMP,"/boot/home/apachesrc/$key");
	print RESULT "\n Output of $results_hash{$key}:\n\n";
	while (<TEMP>) { print RESULT $_; }
	close(RESULT);
	close(TEMP);
	unlink "/boot/home/apachesrc/$key";
}

system("kill", "httpd");

